﻿fl.outputPanel.clear();

//open a blank file to prevent error on setupDialog:
var dummyFla = fl.createDocument(); 

//======= FOR TESTING: =======
//var setupDialog = fl.getDocumentDOM().xmlPanel("file:///C:/Documents and Settings/Wasted Potential/Desktop/New Command/Rename Class Package.xml");
//var setupDialog = fl.getDocumentDOM().xmlPanel("file:///C:/Users/Admin/Desktop/New Command/New Command/Rename Class Package.xml");
//======= FOR PACKAGING FINAL MXP: =======
var setupDialog = fl.getDocumentDOM().xmlPanel(fl.configURI + "/Commands/Rename Class Package.xml"); 

var packageToReplace = setupDialog.oldpackage;
var packageFolder = packageToReplace.replace(".", "/");
var newPackage =setupDialog.newpackage;
var newPackageFolder = newPackage.replace(".", "/")
var showSavePrompt = true;
if (setupDialog.autosave == "true") {
	showSavePrompt = false;
}

if (setupDialog.dismiss == "cancel") {
	fl.closeDocument(dummyFla, false); //close dummy file that we opened in the beginning
	alert("Class package renaming cancelled.");
}
else if (packageToReplace == null || packageToReplace == '' || newPackage == null || newPackage == '' || packageToReplace == newPackage) {
	//display failure message:
	fl.closeDocument(dummyFla, false); //close dummy file that we opened in the beginning
	alert("Class package renaming cancelled. Invalid class package.");
}
else {
	//begin setup:
	var updatedFlaFiles = [];
	var updatedAsFiles =[];
	
	var projectPath = fl.browseForFolderURL("Select the source folder for your project");
	
	if (projectPath == null) { //skip if user cancels
		fl.closeDocument(dummyFla, false); //close dummy file that we opened in the beginning
		alert("Class package renaming cancelled.");
	}
	else { //if user hits OK, then proceed:
		
		//add a final check here to safeguard against user doing find and replace on their main hard drive folder:
		var finalConfirm = confirm("Please confirm that you would like to replace all class package references in the following folder:\r\n"+projectPath);
		if (finalConfirm == false) {
			fl.closeDocument(dummyFla, false); //close dummy file that we opened in the beginning
			alert("Class package renaming cancelled.");
		}
		else {
		
			var subfoldersArray = getAllSubfolders(projectPath);
			
			//get all *.fla files:
			var flaFileArray = [];
			for (i=0; i<subfoldersArray.length; i++) {
				var tempFlaArray = FLfile.listFolder(projectPath+subfoldersArray[i]+"/*.fla", "files");
				for (j=0; j<tempFlaArray.length; j++) {
					flaFileArray.push(subfoldersArray[i]+"/"+tempFlaArray[j]);
				}
			}
			//rename linkages in all *.fla files:
			for (i=0; i<flaFileArray.length; i++) {
				if (renameClassPaths(projectPath+flaFileArray[i], packageToReplace, newPackage, showSavePrompt)) {
					updatedFlaFiles.push(flaFileArray[i]);
				}
			}			
			
			//get all *.as files:
			var asFileArray = [];
			for (i=0; i<subfoldersArray.length; i++) {
				var tempAsArray = FLfile.listFolder(projectPath+subfoldersArray[i]+"/*.as", "files");
				for (j=0; j<tempAsArray.length; j++) {
					asFileArray.push(subfoldersArray[i]+"/"+tempAsArray[j]);
				}
			}
			//rename packages in all *.as files:
			for (i=0; i<asFileArray.length; i++) {
				if (renameClassPackages(projectPath+asFileArray[i], packageToReplace, newPackage)) {
					updatedAsFiles.push(asFileArray[i]);
				}
			}
			
			//rename package folder:		
			for (i=0; i<subfoldersArray.length; i++) {
				var folderSplit = subfoldersArray[i].split(packageFolder)
				if (folderSplit.length > 1) {
					var oldClassFolder = folderSplit[0]+packageFolder;
					var newClassFolder = folderSplit[0]+newPackageFolder;
					renameFolder(projectPath+oldClassFolder, projectPath+newClassFolder);
					break;
				}
			}
			
			//close dummy file that we opened in the beginning:
			fl.closeDocument(dummyFla, false);
			
			//display results message
			var outputMsg = "Class package renamed in the following files:\r\n";
			for (i=0; i<updatedFlaFiles.length; i++) {
				outputMsg += updatedFlaFiles[i];
				outputMsg += "\r\n";
			}
			for (i=0; i<updatedAsFiles.length; i++) {
				outputMsg += updatedAsFiles[i].replace(packageFolder, newPackageFolder);
				outputMsg += "\r\n";
			}
			alert(outputMsg);
			
			//done.
		}
	}
}

//- recursively finds all subfolders in a given root folder. returns an array of subfolders.
function getAllSubfolders(startFolder) {
	var dirArray = [];
	var localDir = "";
	dirArray.push(localDir);
	currentIndex = 0;
	while(currentIndex < dirArray.length) {
		//fl.trace(currentIndex+", "+projectPath+localDir);
		var tempArray = FLfile.listFolder(startFolder+localDir, "directories");
		//loop through results and add valid folders to array
		for (i=0; i<tempArray.length; i++) {
			if (tempArray[i].charAt(0) != ".") { //ignore ".svn" folders
				dirArray.push(localDir+"/"+tempArray[i]);
			}
		}
		currentIndex++;
		if (currentIndex < dirArray.length) {
			localDir = dirArray[currentIndex];
		}
	}
	return dirArray;
}

//- renames the all class package in an .as file:
function renameClassPackages(asFilePath, oldPackageName, newPackageName) {
	//open the actionscript file
	var asFileContents = FLfile.read(asFilePath);
	var found = false;
	//only do a string replace and save if necessary:
	if (asFileContents && asFileContents.indexOf(oldPackageName) >=0 ) {
		asFileContents = asFileContents.replace(oldPackageName, newPackageName);
		FLfile.write(asFilePath, asFileContents);	
		found = true;
	}
	return found;
}

//- renames all class linkages in a given FLA file:
function renameClassPaths(flaFilePath, oldPackageName, newPackageName, promptSave) {
	var found = false;
		
	//open fla file (this will fail if it is saved in higher version than the version of flash you are running:
	tempFla = fl.openDocument(flaFilePath);
	
	//rename document class:
	var origDocClass = tempFla.docClass;
	tempFla.docClass = origDocClass.replace(oldPackageName, newPackageName);
	if (origDocClass != tempFla.docClass) {
		found = true;
	}
	
	//loop through library and rename all linkages or base classes:
	for( var h=0; h<tempFla.library.items.length; h++){
    	var item = tempFla.library.items[h];
		//search and replace all linkages/base classes:
    	if(item.itemType=='movie clip'){
      		if(item.linkageClassName!=  '' && item.linkageClassName != undefined && item.linkageClassName != null) {
        		var origLinkage = item.linkageClassName;
        		item.linkageClassName = origLinkage.replace(oldPackageName, newPackageName);
				var origBaseClass = item.linkageBaseClass;
				item.linkageBaseClass = origBaseClass.replace(oldPackageName, newPackageName);
				if (origLinkage != item.linkageClassName || origBaseClass != item.linkageBaseClass) {
					found = true;
				}
			}
      	}
	}
	
	//close file:
	if (found) { //changes need to be saved:
		if (promptSave) { //prompt user to save:
			fl.closeDocument(tempFla, true);
		}
		else { //save without user prompt:
			fl.saveDocument(tempFla);
			fl.closeDocument(tempFla, false);
		}
	}
	else { //no changes, just close it.
		fl.closeDocument(tempFla, false);
	}
	
	return found;
}

//- moves all subfolders and files from one directory to another. 
//- Then, deletes the original.
function renameFolder(sourcePath, targetPath) {
    FLfile.createFolder(targetPath);
    copyFolders(sourcePath, targetPath, FLfile.listFolder(sourcePath, "directories"));
    copyFiles(sourcePath, targetPath, FLfile.listFolder(sourcePath, "files"));
    FLfile.remove(sourcePath);
}

//- helper fxn: copies all folders from one directory to another:
function copyFolders(sourcePath, targetPath, folderList) {
    var i = folderList.length;
    while (i--) {
        FLfile.createFolder(targetPath + "/" + folderList[i]);
        copyFiles(sourcePath + "/" + folderList[i], targetPath + "/" + folderList[i], FLfile.listFolder(sourcePath + "/" + folderList[i], "files"));
        copyFolders(sourcePath + "/" + folderList[i], targetPath + "/" + folderList[i], FLfile.listFolder(sourcePath + "/" + folderList[i], "directories"));
    }
}

//- helper fxn: copies all files from one directory to another:
function copyFiles(sourcePath, targetPath, fileList) {
    var i = fileList.length;
    while (i--) {
        FLfile.copy(sourcePath + "/" + fileList[i], targetPath + "/" + fileList[i]);
    }
}
